<?php
$title = "Nominate";
headers(array('title'=>$title,'menu'=>1));

if(!$_GET['id']) {
  echo '<p class="error">No Election Position ID specified.</p>';
  exit(0);
}

require_once 'backend/election.inc';

$positionrow = sql_select1("election_position","election_id",
			  "id=".$dbh->quote($_GET['id']));

$election = get_election($positionrow->election_id);

$nomination_cnt = sql_select1("election_candidate_nomination",
			  "count(*) as cnt",
			  "election_position_id=".$dbh->quote($_GET['id']).
			  " and for_member_id=".
			  $dbh->quote(get_member_id($_SESSION['user'])));

if($nomination_cnt->cnt < $election['num_req_nominations']) {
  echo '<p class="error">Not enough nominations for this position.</p>';
  exit(0);
}

if($election['nominations-status']!='open') {
  echo '<p class="error">Election nominations are closed. You can no longer accept the nomination.</p>';
  exit(0);
}


$new_candidate_form = array(
			    'spiel'=>array('type'=>'textarea',
					   'label'=>'Spiel',
					   'cols'=>40,
					   'rows'=>5,
					   )
			    );

$errors = validate($new_candidate_form, $_POST);

?>
<?php
if($errors || $_POST['Accept']!='Accept') {
?>
<h2>Accept Nomination</h2>
<p>You are about to accept a nomination for a position.</p>

<dl>
<dt>Election</dt>
<dd><?=$election['name']?></dd>
<dt>Position</dt>
<dd><?=$election['position'][$_GET['id']]['name']?></dd>
</dl>

<?php

  echo '<div class="stdform">';
  print $errors;
  output_form($new_candidate_form,"new_candidate","Accept","post",
	      "&id=".$_GET['id']);
  echo '</div>';
} else {
  $sql = "insert into election_candidate (election_position_id,member_id,spiel)"
    ." values ("
    .$dbh->quote($_GET['id']).", "
    .$dbh->quote(get_member_id($_SESSION['user'])).", "
    .$dbh->quote($_POST['spiel']).")";
  $result = $dbh->query($sql);
  if(DB::isError($result)) {
    echo '<p class="error">Error submitting acceptance of nomination.</p>';
    my_syslog(LOG_ERR,'election-new-candidate: '.var_export($result,true));
    if($result->getCode()==DB_ERROR_CONSTRAINT
       && strstr($result->getUserInfo(),'election_candidate_pkey')
       ) {
      echo '<p class="error">You have already accepted this nomination.</p>';
    }
  } else {
?>

<h2>Accepted Nomination</h2>
<p>You have accepted the nomination.</p>
<dl>
<dt>Election</dt>
<dd><?=$election['name']?></dd>
<dt>Position</dt>
<dd><?=$election['position'][$_GET['id']]['name']?></dd>
</dl>

<?php
   }
}
?>
